#include "FileInfo.h"

FileInfo::FileInfo(const char* name,const char* basedir,const char* subdir)
{
	m_name=new char[strlen(name)+1];
	m_subdir=new char[strlen(subdir)+1];
	m_basedir=new char[strlen(basedir)+1];
	
	strcpy(m_name,name);
	strcpy(m_basedir,basedir);
	strcpy(m_subdir,subdir);
	
	m_FoundCount=0;
	m_FoundName=NULL;
	m_FoundBasedir=NULL;
	m_FoundSubdir=NULL;
	m_isEqual=NULL;
}

FileInfo::~FileInfo()
{
	for(int i=0;i<m_FoundCount;i++){
		delete m_FoundName[i];
		delete m_FoundBasedir[i];
		delete m_FoundSubdir[i];
	}
	free(m_FoundName);
	free(m_FoundSubdir);
	free(m_FoundBasedir);
	free(m_isEqual);
	
	delete m_name;
	delete m_basedir;
	delete m_subdir;
}

void FileInfo::AddFound(const char* name,const char* basedir,const char* sub,bool isequal)
{
	m_FoundName=(char**)realloc(m_FoundName,sizeof(char*)*(m_FoundCount+1));
	m_FoundSubdir=(char**)realloc(m_FoundSubdir,sizeof(char*)*(m_FoundCount+1));
	m_FoundBasedir=(char**)realloc(m_FoundBasedir,sizeof(char*)*(m_FoundCount+1));
	m_isEqual=(bool*)realloc(m_isEqual,sizeof(bool)*(m_FoundCount+1));
	
	m_FoundName[m_FoundCount]=new char[strlen(name)+1];
	strcpy(m_FoundName[m_FoundCount],name);
	m_FoundBasedir[m_FoundCount]=new char[strlen(basedir)+1];
	strcpy(m_FoundBasedir[m_FoundCount],basedir);
	m_FoundSubdir[m_FoundCount]=new char[strlen(sub)+1];
	strcpy(m_FoundSubdir[m_FoundCount],sub);
	m_isEqual[m_FoundCount]=isequal;
	
	m_FoundCount++;
}
